diff -uNr openmp-3.5.0.src/runtime/src/kmp_runtime.c openmp-3.5.0.src.r219214/runtime/src/kmp_runtime.c
--- openmp-3.5.0.src/runtime/src/kmp_runtime.c	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/kmp_runtime.c	2014-10-24 19:58:41.000000000 -0400
@@ -1,7 +1,7 @@
 /*
  * kmp_runtime.c -- KPTS runtime support library
- * $Revision: 42839 $
- * $Date: 2013-11-24 13:01:00 -0600 (Sun, 24 Nov 2013) $
+ * $Revision: 43473 $
+ * $Date: 2014-09-26 15:02:57 -0500 (Fri, 26 Sep 2014) $
  */
 
 
@@ -25,26 +25,13 @@
 #include "kmp_i18n.h"
 #include "kmp_io.h"
 #include "kmp_error.h"
+#include "kmp_stats.h"
+#include "kmp_wait_release.h"
 
 /* these are temporary issues to be dealt with */
 #define KMP_USE_PRCTL 0
 #define KMP_USE_POOLED_ALLOC 0
 
-#if KMP_MIC
-#include <immintrin.h>
-#define USE_NGO_STORES 1
-#endif // KMP_MIC
-
-#if KMP_MIC && USE_NGO_STORES
-#define load_icvs(src)         __m512d Vt_icvs = _mm512_load_pd((void *)(src))
-#define store_icvs(dst, src)   _mm512_storenrngo_pd((void *)(dst), Vt_icvs)
-#define sync_icvs()            __asm__ volatile ("lock; addl $0,0(%%rsp)" ::: "memory")
-#else
-#define load_icvs(src)         ((void)0)
-#define store_icvs(dst, src)   copy_icvs((dst), (src))
-#define sync_icvs()            ((void)0)
-#endif /* KMP_MIC && USE_NGO_STORES */
-
 #if KMP_OS_WINDOWS
 #include <process.h>
 #endif
@@ -57,34 +44,12 @@
 char const __kmp_version_omp_api[] = KMP_VERSION_PREFIX "API version: "
 #if OMP_40_ENABLED
     "4.0 (201307)";
-#elif OMP_30_ENABLED
-    "3.1 (201107)";
 #else
-    "2.5 (200505)";
+    "3.1 (201107)";
 #endif
 
 #ifdef KMP_DEBUG
-
 char const __kmp_version_lock[] = KMP_VERSION_PREFIX "lock type: run time selectable";
-
-char const __kmp_version_perf_v19[] = KMP_VERSION_PREFIX "perf v19: "
-#if KMP_PERF_V19 == KMP_ON
-    "on";
-#elif KMP_PERF_V19 == KMP_OFF
-    "off";
-#else
-    #error "Must specify KMP_PERF_V19 option"
-#endif
-
-char const __kmp_version_perf_v106[] = KMP_VERSION_PREFIX "perf v106: "
-#if KMP_PERF_V106 == KMP_ON
-    "on";
-#elif KMP_PERF_V106 == KMP_OFF
-    "off";
-#else
-    #error "Must specify KMP_PERF_V106 option"
-#endif
-
 #endif /* KMP_DEBUG */
 
 
@@ -103,19 +68,12 @@
 void __kmp_cleanup( void );
 
 static void __kmp_initialize_info( kmp_info_t *, kmp_team_t *, int tid, int gtid );
-static void __kmp_initialize_team(
-    kmp_team_t * team,
-    int          new_nproc,
-    #if OMP_30_ENABLED
-        kmp_internal_control_t * new_icvs,
-        ident_t *                loc
-    #else
-        int new_set_nproc, int new_set_dynamic, int new_set_nested,
-        int new_set_blocktime, int new_bt_intervals, int new_bt_set
-    #endif // OMP_30_ENABLED
-);
+static void __kmp_initialize_team( kmp_team_t * team, int new_nproc, kmp_internal_control_t * new_icvs, ident_t * loc );
 static void __kmp_partition_places( kmp_team_t *team );
 static void __kmp_do_serial_initialize( void );
+void __kmp_fork_barrier( int gtid, int tid );
+void __kmp_join_barrier( int gtid );
+void __kmp_setup_icv_copy( kmp_team_t *team, int new_nproc, kmp_internal_control_t * new_icvs, ident_t *loc );
 
 
 #ifdef USE_LOAD_BALANCE
@@ -189,8 +147,8 @@
         kmp_info_t *thr = (kmp_info_t *)TCR_SYNC_PTR(other_threads[i]);
         if( !thr ) continue;
 
-        stack_size =  (size_t)TCR_PTR(thr -> th.th_info.ds.ds_stacksize);
-        stack_base =  (char *)TCR_PTR(thr -> th.th_info.ds.ds_stackbase);
+        stack_size =  (size_t)TCR_PTR(thr->th.th_info.ds.ds_stacksize);
+        stack_base =  (char *)TCR_PTR(thr->th.th_info.ds.ds_stackbase);
 
         /* stack grows down -- search through all of the active threads */
 
@@ -221,7 +179,7 @@
         KMP_FATAL( StackOverflow, i );
     }
 
-    stack_base = (char *) other_threads[i] -> th.th_info.ds.ds_stackbase;
+    stack_base = (char *) other_threads[i]->th.th_info.ds.ds_stackbase;
     if( stack_addr > stack_base ) {
         TCW_PTR(other_threads[i]->th.th_info.ds.ds_stackbase, stack_addr);
         TCW_PTR(other_threads[i]->th.th_info.ds.ds_stacksize,
@@ -232,10 +190,10 @@
 
     /* Reprint stack bounds for ubermaster since they have been refined */
     if ( __kmp_storage_map ) {
-        char *stack_end = (char *) other_threads[i] -> th.th_info.ds.ds_stackbase;
-        char *stack_beg = stack_end - other_threads[i] -> th.th_info.ds.ds_stacksize;
+        char *stack_end = (char *) other_threads[i]->th.th_info.ds.ds_stackbase;
+        char *stack_beg = stack_end - other_threads[i]->th.th_info.ds.ds_stacksize;
         __kmp_print_storage_map_gtid( i, stack_beg, stack_end,
-                                      other_threads[i] -> th.th_info.ds.ds_stacksize,
+                                      other_threads[i]->th.th_info.ds.ds_stacksize,
                                       "th_%d stack (refinement)", i );
     }
     return i;
@@ -294,8 +252,8 @@
 
     KA_TRACE(10,("__kmp_check_stack_overlap: called\n"));
     if ( __kmp_storage_map ) {
-        stack_end = (char *) th -> th.th_info.ds.ds_stackbase;
-        stack_beg = stack_end - th -> th.th_info.ds.ds_stacksize;
+        stack_end = (char *) th->th.th_info.ds.ds_stackbase;
+        stack_beg = stack_end - th->th.th_info.ds.ds_stacksize;
 
         gtid = __kmp_gtid_from_thread( th );
 
@@ -315,8 +273,8 @@
     {
         KA_TRACE(10,("__kmp_check_stack_overlap: performing extensive checking\n"));
         if ( stack_beg == NULL ) {
-            stack_end = (char *) th -> th.th_info.ds.ds_stackbase;
-            stack_beg = stack_end - th -> th.th_info.ds.ds_stacksize;
+            stack_end = (char *) th->th.th_info.ds.ds_stackbase;
+            stack_beg = stack_end - th->th.th_info.ds.ds_stacksize;
         }
 
         for( f=0 ; f < __kmp_threads_capacity ; f++ ) {
@@ -347,279 +305,6 @@
 
 /* ------------------------------------------------------------------------ */
 
-#ifndef KMP_DEBUG
-# define __kmp_static_delay( arg )     /* nothing to do */
-#else
-
-static void
-__kmp_static_delay( int arg )
-{
-/* Work around weird code-gen bug that causes assert to trip */
-# if KMP_ARCH_X86_64 && KMP_OS_LINUX
-    KMP_ASSERT( arg != 0 );
-# else
-    KMP_ASSERT( arg >= 0 );
-# endif
-}
-#endif /* KMP_DEBUG */
-
-static void
-__kmp_static_yield( int arg )
-{
-    __kmp_yield( arg );
-}
-
-/*
- * Spin wait loop that first does pause, then yield, then sleep.
- * Wait until spinner is equal to checker to exit.
- *
- * A thread that calls __kmp_wait_sleep must make certain that another thread
- * calls __kmp_release to wake it back up up to prevent deadlocks!
- */
-
-void
-__kmp_wait_sleep( kmp_info_t *this_thr,
-                  volatile kmp_uint *spinner,
-                  kmp_uint checker,
-                  int final_spin
-                  USE_ITT_BUILD_ARG (void * itt_sync_obj)
-)
-{
-    /* note: we may not belong to a team at this point */
-    register volatile kmp_uint    *spin      = spinner;
-    register          kmp_uint     check     = checker;
-    register          kmp_uint32   spins;
-    register          kmp_uint32   hibernate;
-                      int          th_gtid, th_tid;
-#if OMP_30_ENABLED
-                      int          flag = FALSE;
-#endif /* OMP_30_ENABLED */
-
-    KMP_FSYNC_SPIN_INIT( spin, NULL );
-    if( TCR_4(*spin) == check ) {
-        KMP_FSYNC_SPIN_ACQUIRED( spin );
-        return;
-    }
-
-    th_gtid = this_thr->th.th_info.ds.ds_gtid;
-
-    KA_TRACE( 20, ("__kmp_wait_sleep: T#%d waiting for spin(%p) == %d\n",
-                  th_gtid,
-                  spin, check ) );
-
-    /* setup for waiting */
-    KMP_INIT_YIELD( spins );
-
-    if ( __kmp_dflt_blocktime != KMP_MAX_BLOCKTIME ) {
-        //
-        // The worker threads cannot rely on the team struct existing at this
-        // point.  Use the bt values cached in the thread struct instead.
-        //
- #ifdef KMP_ADJUST_BLOCKTIME
-        if ( __kmp_zero_bt && ! this_thr->th.th_team_bt_set ) {
-            /* force immediate suspend if not set by user and more threads than available procs */
-            hibernate = 0;
-        } else {
-            hibernate = this_thr->th.th_team_bt_intervals;
-        }
- #else
-        hibernate = this_thr->th.th_team_bt_intervals;
- #endif /* KMP_ADJUST_BLOCKTIME */
-
-        //
-        // If the blocktime is nonzero, we want to make sure that we spin
-        // wait for the entirety of the specified #intervals, plus up to
-        // one interval more.  This increment make certain that this thread
-        // doesn't go to sleep too soon.
-        //
-        if ( hibernate != 0 ) {
-            hibernate++;
-        }
-
-        //
-        // Add in the current time value.
-        //
-        hibernate += TCR_4( __kmp_global.g.g_time.dt.t_value );
-
-        KF_TRACE( 20, ("__kmp_wait_sleep: T#%d now=%d, hibernate=%d, intervals=%d\n",
-                       th_gtid, __kmp_global.g.g_time.dt.t_value, hibernate,
-                       hibernate - __kmp_global.g.g_time.dt.t_value ));
-    }
-
-    KMP_MB();
-
-    /* main wait spin loop */
-    while( TCR_4(*spin) != check ) {
-        int in_pool;
-
-#if OMP_30_ENABLED
-        //
-        // If the task team is NULL, it means one of things:
-        //   1) A newly-created thread is first being released by
-        //      __kmp_fork_barrier(), and its task team has not been set up
-        //      yet.
-        //   2) All tasks have been executed to completion, this thread has
-        //      decremented the task team's ref ct and possibly deallocated
-        //      it, and should no longer reference it.
-        //   3) Tasking is off for this region.  This could be because we
-        //      are in a serialized region (perhaps the outer one), or else
-        //      tasking was manually disabled (KMP_TASKING=0).
-        //
-        kmp_task_team_t * task_team = NULL;
-        if ( __kmp_tasking_mode != tskm_immediate_exec ) {
-            task_team = this_thr->th.th_task_team;
-            if ( task_team != NULL ) {
-                if ( ! TCR_SYNC_4( task_team->tt.tt_active ) ) {
-                    KMP_DEBUG_ASSERT( ! KMP_MASTER_TID( this_thr->th.th_info.ds.ds_tid ) );
-                    __kmp_unref_task_team( task_team, this_thr );
-                } else if ( KMP_TASKING_ENABLED( task_team, this_thr->th.th_task_state ) ) {
-                    __kmp_execute_tasks( this_thr, th_gtid, spin, check, final_spin, &flag
-                                         USE_ITT_BUILD_ARG( itt_sync_obj ), 0);
-                }
-            }; // if
-        }; // if
-#endif /* OMP_30_ENABLED */
-
-        KMP_FSYNC_SPIN_PREPARE( spin );
-        if( TCR_4(__kmp_global.g.g_done) ) {
-            if( __kmp_global.g.g_abort )
-                __kmp_abort_thread( );
-            break;
-        }
-
-        __kmp_static_delay( 1 );
-
-        /* if we are oversubscribed,
-           or have waited a bit (and KMP_LIBRARY=throughput), then yield */
-        KMP_YIELD( TCR_4(__kmp_nth) > __kmp_avail_proc );
-        // TODO: Should it be number of cores instead of thread contexts? Like:
-        // KMP_YIELD( TCR_4(__kmp_nth) > __kmp_ncores );
-        // Need performance improvement data to make the change...
-        KMP_YIELD_SPIN( spins );
-
-        //
-        // Check if this thread was transferred from a team
-        // to the thread pool (or vice-versa) while spinning.
-        //
-        in_pool = !!TCR_4(this_thr->th.th_in_pool);
-        if ( in_pool != !!this_thr->th.th_active_in_pool ) {
-            if ( in_pool ) {
-                //
-                // recently transferred from team to pool
-                //
-                KMP_TEST_THEN_INC32(
-                                    (kmp_int32 *) &__kmp_thread_pool_active_nth );
-                this_thr->th.th_active_in_pool = TRUE;
-
-                //
-                // Here, we cannot assert that
-                //
-                // KMP_DEBUG_ASSERT( TCR_4(__kmp_thread_pool_active_nth)
-                //  <= __kmp_thread_pool_nth );
-                //
-                // __kmp_thread_pool_nth is inc/dec'd by the master thread
-                // while the fork/join lock is held, whereas
-                // __kmp_thread_pool_active_nth is inc/dec'd asynchronously
-                // by the workers.  The two can get out of sync for brief
-                // periods of time.
-                //
-            }
-            else {
-                //
-                // recently transferred from pool to team
-                //
-                KMP_TEST_THEN_DEC32(
-                                    (kmp_int32 *) &__kmp_thread_pool_active_nth );
-                KMP_DEBUG_ASSERT( TCR_4(__kmp_thread_pool_active_nth) >= 0 );
-                this_thr->th.th_active_in_pool = FALSE;
-            }
-        }
-
-#if OMP_30_ENABLED
-        // Don't suspend if there is a likelihood of new tasks being spawned.
-        if ( ( task_team != NULL ) && TCR_4(task_team->tt.tt_found_tasks) ) {
-            continue;
-        }
-#endif /* OMP_30_ENABLED */
-
-        /* Don't suspend if KMP_BLOCKTIME is set to "infinite" */
-        if ( __kmp_dflt_blocktime == KMP_MAX_BLOCKTIME ) {
-            continue;
-        }
-
-        /* if we have waited a bit more, fall asleep */
-        if ( TCR_4( __kmp_global.g.g_time.dt.t_value ) < hibernate ) {
-            continue;
-        }
-
-        KF_TRACE( 50, ("__kmp_wait_sleep: T#%d suspend time reached\n", th_gtid ) );
-
-        __kmp_suspend( th_gtid, spin, check );
-
-        if( TCR_4( __kmp_global.g.g_done ) && __kmp_global.g.g_abort ) {
-            __kmp_abort_thread( );
-        }
-
-        /* TODO */
-        /* if thread is done with work and timesout, disband/free */
-    }
-
-    KMP_FSYNC_SPIN_ACQUIRED( spin );
-}
-
-
-/*
- * Release the thread specified by target_thr from waiting by setting the location
- * specified by spin and resume the thread if indicated by the sleep parameter.
- *
- * A thread that calls __kmp_wait_sleep must call this function to wake up the
- * potentially sleeping thread and prevent deadlocks!
- */
-
-void
-__kmp_release( kmp_info_t *target_thr, volatile kmp_uint *spin,
-               enum kmp_mem_fence_type fetchadd_fence )
-{
-    kmp_uint old_spin;
-    #ifdef KMP_DEBUG
-        int target_gtid = target_thr->th.th_info.ds.ds_gtid;
-        int gtid = TCR_4(__kmp_init_gtid) ? __kmp_get_gtid() : -1;
-    #endif
-
-    KF_TRACE( 20, ( "__kmp_release: T#%d releasing T#%d spin(%p) fence_type(%d)\n",
-                    gtid, target_gtid, spin, fetchadd_fence ));
-
-    KMP_DEBUG_ASSERT( spin );
-
-    KMP_DEBUG_ASSERT( fetchadd_fence == kmp_acquire_fence ||
-                      fetchadd_fence == kmp_release_fence );
-
-    KMP_FSYNC_RELEASING( spin );
-
-    old_spin = ( fetchadd_fence == kmp_acquire_fence )
-                 ? KMP_TEST_THEN_ADD4_ACQ32( (volatile kmp_int32 *) spin )
-                 : KMP_TEST_THEN_ADD4_32( (volatile kmp_int32 *) spin );
-
-    KF_TRACE( 100, ( "__kmp_release: T#%d old spin(%p)=%d, set new spin=%d\n",
-                     gtid, spin, old_spin, *spin ) );
-
-    if ( __kmp_dflt_blocktime != KMP_MAX_BLOCKTIME ) {
-        /* Only need to check sleep stuff if infinite block time not set */
-        if ( old_spin & KMP_BARRIER_SLEEP_STATE ) {
- #ifndef KMP_DEBUG
-            int target_gtid = target_thr->th.th_info.ds.ds_gtid;
- #endif
-            /* wake up thread if needed */
-            KF_TRACE( 50, ( "__kmp_release: T#%d waking up thread T#%d since sleep spin(%p) set\n",
-                            gtid, target_gtid, spin ));
-            __kmp_resume( target_gtid, spin );
-        } else {
-            KF_TRACE( 50, ( "__kmp_release: T#%d don't wake up thread T#%d since sleep spin(%p) not set\n",
-                            gtid, target_gtid, spin ));
-        }
-    }
-}
-
 /* ------------------------------------------------------------------------ */
 
 void
@@ -848,13 +533,11 @@
     __kmp_print_storage_map_gtid( -1, &team->t.t_set_bt_set[0], &team->t.t_set_bt_set[num_thr],
                              sizeof(int) * num_thr, "%s_%d.t_set_nested", header, team_id );
 
-#if OMP_30_ENABLED
     //__kmp_print_storage_map_gtid( -1, &team->t.t_set_max_active_levels[0], &team->t.t_set_max_active_levels[num_thr],
     //                        sizeof(int) * num_thr, "%s_%d.t_set_max_active_levels", header, team_id );
 
     __kmp_print_storage_map_gtid( -1, &team->t.t_set_sched[0], &team->t.t_set_sched[num_thr],
                              sizeof(kmp_r_sched_t) * num_thr, "%s_%d.t_set_sched", header, team_id );
-#endif // OMP_30_ENABLED
 #if OMP_40_ENABLED
     __kmp_print_storage_map_gtid( -1, &team->t.t_set_proc_bind[0], &team->t.t_set_proc_bind[num_thr],
                              sizeof(kmp_proc_bind_t) * num_thr, "%s_%d.t_set_proc_bind", header, team_id );
@@ -953,7 +636,7 @@
                 // the problem of unreleased forkjoin lock as described below.
 
                 // A worker thread can take the forkjoin lock
-                // in __kmp_suspend()->__kmp_rml_decrease_load_before_sleep().
+                // in __kmp_suspend_template()->__kmp_rml_decrease_load_before_sleep().
                 // The problem comes up if that worker thread becomes dead
                 // before it releases the forkjoin lock.
                 // The forkjoin lock remains taken, while the thread
@@ -1034,15 +717,15 @@
 #endif /* BUILD_PARALLEL_ORDERED */
 
     if( __kmp_env_consistency_check ) {
-        if( __kmp_threads[gtid] -> th.th_root -> r.r_active )
+        if( __kmp_threads[gtid]->th.th_root->r.r_active )
             __kmp_push_sync( gtid, ct_ordered_in_parallel, loc_ref, NULL );
     }
 #ifdef BUILD_PARALLEL_ORDERED
-    if( !team -> t.t_serialized ) {
+    if( !team->t.t_serialized ) {
         kmp_uint32  spins;
 
         KMP_MB();
-        KMP_WAIT_YIELD(&team -> t.t_ordered.dt.t_value, __kmp_tid_from_gtid( gtid ), KMP_EQ, NULL);
+        KMP_WAIT_YIELD(&team->t.t_ordered.dt.t_value, __kmp_tid_from_gtid( gtid ), KMP_EQ, NULL);
         KMP_MB();
     }
 #endif /* BUILD_PARALLEL_ORDERED */
@@ -1062,16 +745,16 @@
 #endif /* BUILD_PARALLEL_ORDERED */
 
     if( __kmp_env_consistency_check ) {
-        if( __kmp_threads[gtid] -> th.th_root -> r.r_active )
+        if( __kmp_threads[gtid]->th.th_root->r.r_active )
             __kmp_pop_sync( gtid, ct_ordered_in_parallel, loc_ref );
     }
 #ifdef BUILD_PARALLEL_ORDERED
-    if ( ! team -> t.t_serialized ) {
+    if ( ! team->t.t_serialized ) {
         KMP_MB();       /* Flush all pending memory write invalidates.  */
 
         /* use the tid of the next thread in this team */
         /* TODO repleace with general release procedure */
-        team -> t.t_ordered.dt.t_value = ((tid + 1) % team->t.t_nproc );
+        team->t.t_ordered.dt.t_value = ((tid + 1) % team->t.t_nproc );
 
         KMP_MB();       /* Flush all pending memory write invalidates.  */
     }
@@ -1097,12 +780,12 @@
         __kmp_parallel_initialize();
 
     th   = __kmp_threads[ gtid ];
-    team = th -> th.th_team;
+    team = th->th.th_team;
     status = 0;
 
     th->th.th_ident = id_ref;
 
-    if ( team -> t.t_serialized ) {
+    if ( team->t.t_serialized ) {
         status = 1;
     } else {
         kmp_int32 old_this = th->th.th_local.this_construct;
@@ -1112,7 +795,7 @@
            single block
         */
         /* TODO: Should this be acquire or release? */
-        status = KMP_COMPARE_AND_STORE_ACQ32(&team -> t.t_construct, old_this,
+        status = KMP_COMPARE_AND_STORE_ACQ32(&team->t.t_construct, old_this,
                                              th->th.th_local.this_construct);
     }
 
@@ -1127,6 +810,10 @@
     if ( status ) {
         __kmp_itt_single_start( gtid );
     }
+    if( __itt_metadata_add_ptr && __kmp_forkjoin_frames_mode == 3 ) {
+        __kmp_itt_metadata_single();
+    }
+
 #endif /* USE_ITT_BUILD */
     return status;
 }
